import 'regenerator-runtime/runtime';
import _get from 'lodash/fp/get';
import React, { useContext, useEffect, useReducer } from 'react';
import ApolloClient, { gql } from 'apollo-boost';
import { ApolloProvider, useQuery, useMutation } from 'react-apollo-hooks';
import _curry from 'lodash/fp/curry';
import _merge from 'lodash/fp/merge';
import _compose from 'lodash/fp/compose';
import _map from 'lodash/fp/map';

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

// Returns a normalized result from a mutation call to ensure data and errors
// are returned in an expected shape.
var mutationResultNormalizer = _curry(function () {
  var rootPath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var resourcePath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var result = arguments.length > 2 ? arguments[2] : undefined;

  var root = _get(['data', rootPath], result); // Different mutations use different error names, so normalize to a single
  // name.


  var errors = _get('checkoutUserErrors', root) || _get('customerUserErrors', root) || _get('userErrors', root) || []; // If a resource path is not defined, return undefined since Shopify does
  // not provide any meaningful return data for this mutation.

  var data = resourcePath ? _get(resourcePath, root) : undefined;
  return {
    data: data,
    errors: errors
  };
});

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentDiscountApplication on DiscountApplication {\n    targetSelection\n    allocationMethod\n    targetType\n    ... on ManualDiscountApplication {\n      title\n      description\n    }\n    ... on DiscountCodeApplication {\n      code\n      applicable\n    }\n    ... on ScriptDiscountApplication {\n      description\n    }\n    ... on AutomaticDiscountApplication {\n      title\n    }\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentDiscountApplication = gql(_templateObject());

function _templateObject$1() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentMailingAddress on MailingAddress {\n    id\n    address1\n    address2\n    city\n    company\n    country\n    firstName\n    formatted\n    lastName\n    latitude\n    longitude\n    phone\n    province\n    zip\n    name\n    countryCode: countryCodeV2\n    provinceCode\n  }\n"]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentMailingAddress = gql(_templateObject$1());

function _templateObject$2() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentProductVariant on ProductVariant {\n    id\n    title\n    price\n    weight\n    available: availableForSale\n    sku\n    compareAtPrice\n    image {\n      id\n      src: originalSrc\n      altText\n    }\n    selectedOptions {\n      name\n      value\n    }\n  }\n"]);

  _templateObject$2 = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentProductVariant = gql(_templateObject$2());

function _templateObject$3() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentProductVariantWithProduct on ProductVariant {\n    ...FragmentProductVariant\n    product {\n      id\n    }\n  }\n\n  ", "\n"]);

  _templateObject$3 = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentProductVariantWithProduct = gql(_templateObject$3(), FragmentProductVariant);

function _templateObject$4() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentCheckout on Checkout {\n    id\n    ready\n    requiresShipping\n    note\n    paymentDue\n    webUrl\n    orderStatusUrl\n    taxExempt\n    taxesIncluded\n    currencyCode\n    totalTax\n    subtotalPrice\n    totalPrice\n    completedAt\n    createdAt\n    updatedAt\n    email\n    discountApplications(first: 10) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        node {\n          ...FragmentDiscountApplication\n        }\n      }\n    }\n    shippingAddress {\n      ...FragmentMailingAddress\n    }\n    shippingLine {\n      handle\n      price\n      title\n    }\n    customAttributes {\n      key\n      value\n    }\n    order {\n      id\n      processedAt\n      orderNumber\n      subtotalPrice\n      totalShippingPrice\n      totalTax\n      totalPrice\n      currencyCode\n      totalRefunded\n      customerUrl\n      shippingAddress {\n        ...FragmentMailingAddress\n      }\n      lineItems(first: 250) {\n        pageInfo {\n          hasNextPage\n          hasPreviousPage\n        }\n        edges {\n          cursor\n          node {\n            title\n            variant {\n              ...FragmentProductVariantWithProduct\n            }\n            quantity\n            customAttributes {\n              key\n              value\n            }\n          }\n        }\n      }\n    }\n    lineItems(first: 250) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          id\n          title\n          variant {\n            ...FragmentProductVariantWithProduct\n          }\n          quantity\n          customAttributes {\n            key\n            value\n          }\n          discountAllocations {\n            allocatedAmount {\n              amount\n              currencyCode\n            }\n            discountApplication {\n              ...FragmentDiscountApplication\n            }\n          }\n        }\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$4 = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentCheckout = gql(_templateObject$4(), FragmentDiscountApplication, FragmentMailingAddress, FragmentProductVariantWithProduct);

function _templateObject$5() {
  var data = _taggedTemplateLiteral(["\n  query($id: ID!) {\n    node(id: $id) {\n      ...FragmentCheckout\n    }\n  }\n\n  ", "\n"]);

  _templateObject$5 = function _templateObject() {
    return data;
  };

  return data;
}
var QueryCheckoutNode = gql(_templateObject$5(), FragmentCheckout);

function _templateObject$6() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentDiscountAllocation on DiscountAllocation {\n    allocatedAmount {\n      amount\n      currencyCode\n    }\n    discountApplication {\n      ...FragmentDiscountApplication\n    }\n  }\n\n  fragment FragmentOrderLineItem on OrderLineItem {\n    customAttributes {\n      key\n      value\n    }\n    discountAllocations {\n      ...FragmentDiscountAllocation\n    }\n    quantity\n    title\n    variant {\n      ...FragmentProductVariant\n    }\n  }\n\n  fragment FragmentFulfillmentLineItem on FulfillmentLineItem {\n    lineItem {\n      ...FragmentOrderLineItem\n    }\n    quantity\n  }\n\n  fragment FragmentFulfillment on Fulfillment {\n    fulfillmentLineItems(first: 250) {\n      edges {\n        cursor\n        node {\n          ...FragmentFulfillmentLineItem\n        }\n      }\n    }\n    trackingCompany\n    trackingInfo(first: 250) {\n      number\n      url\n    }\n  }\n\n  fragment FragmentOrder on Order {\n    currencyCode\n    customerLocale\n    customerUrl\n    discountApplications(first: 250) {\n      edges {\n        cursor\n        node {\n          ...FragmentDiscountApplication\n        }\n      }\n    }\n    email\n    id\n    lineItems(first: 250) {\n      edges {\n        cursor\n        node {\n          ...FragmentOrderLineItem\n        }\n      }\n    }\n    name\n    orderNumber\n    phone\n    processedAt\n    shippingAddress {\n      ...FragmentMailingAddress\n    }\n    shippingDiscountAllocations {\n      ...FragmentDiscountAllocation\n    }\n    statusUrl\n    subtotalPrice\n    successfulFulfillments(first: 250) {\n      ...FragmentFulfillment\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$6 = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentOrder = gql(_templateObject$6(), FragmentDiscountApplication, FragmentMailingAddress, FragmentProductVariant);

function _templateObject$7() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentCustomer on Customer {\n    acceptsMarketing\n    addresses(first: 250) {\n      edges {\n        cursor\n        node {\n          ...FragmentMailingAddress\n        }\n      }\n    }\n    createdAt\n    defaultAddress {\n      ...FragmentMailingAddress\n    }\n    displayName\n    email\n    firstName\n    id\n    lastIncompleteCheckout {\n      id\n    }\n    lastName\n    orders(first: 250) {\n      edges {\n        cursor\n        node {\n          ...FragmentOrder\n        }\n      }\n    }\n    phone\n    tags\n    updatedAt\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$7 = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentCustomer = gql(_templateObject$7(), FragmentMailingAddress, FragmentOrder);

function _templateObject$8() {
  var data = _taggedTemplateLiteral(["\n  query($customerAccessToken: String!) {\n    customer(customerAccessToken: $customerAccessToken) {\n      ...FragmentCustomer\n    }\n  }\n\n  ", "\n"]);

  _templateObject$8 = function _templateObject() {
    return data;
  };

  return data;
}
var QueryCustomer = gql(_templateObject$8(), FragmentCustomer);

function _templateObject$9() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentProduct on Product {\n    id\n    availableForSale\n    createdAt\n    updatedAt\n    descriptionHtml\n    description\n    handle\n    productType\n    title\n    vendor\n    publishedAt\n    onlineStoreUrl\n    options {\n      name\n      values\n    }\n    images(first: 250) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          id\n          src\n          altText\n        }\n      }\n    }\n    variants(first: 250) {\n      edges {\n        cursor\n        node {\n          ...FragmentProductVariant\n        }\n      }\n    }\n  }\n\n  ", "\n"]);

  _templateObject$9 = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentProduct = gql(_templateObject$9(), FragmentProductVariant);

function _templateObject$a() {
  var data = _taggedTemplateLiteral(["\n  query($id: ID!) {\n    node(id: $id) {\n      ...FragmentProduct\n    }\n  }\n\n  ", "\n"]);

  _templateObject$a = function _templateObject() {
    return data;
  };

  return data;
}
var QueryProductNode = gql(_templateObject$a(), FragmentProduct);

function _templateObject$b() {
  var data = _taggedTemplateLiteral(["\n  query($id: ID!) {\n    node(id: $id) {\n      ...FragmentProductVariant\n    }\n  }\n\n  ", "\n"]);

  _templateObject$b = function _templateObject() {
    return data;
  };

  return data;
}
var QueryProductVariantNode = gql(_templateObject$b(), FragmentProductVariant);

function _templateObject$c() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentCustomerAccessToken on CustomerAccessToken {\n    accessToken\n    expiresAt\n  }\n"]);

  _templateObject$c = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentCustomerAccessToken = gql(_templateObject$c());

function _templateObject$d() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentCustomerUserError on CustomerUserError {\n    field\n    message\n    code\n  }\n"]);

  _templateObject$d = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentCustomerUserError = gql(_templateObject$d());

function _templateObject$e() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentUserError on UserError {\n    field\n    message\n  }\n"]);

  _templateObject$e = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentUserError = gql(_templateObject$e());

function _templateObject$f() {
  var data = _taggedTemplateLiteral(["\n  mutation($input: CustomerAccessTokenCreateInput!) {\n    customerAccessTokenCreate(input: $input) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customerAccessToken {\n        ...FragmentCustomerAccessToken\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$f = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerAccessTokenCreate = gql(_templateObject$f(), FragmentCustomerAccessToken, FragmentCustomerUserError, FragmentUserError);

function _templateObject$g() {
  var data = _taggedTemplateLiteral(["\n  mutation($customerAccessToken: String!) {\n    customerAccessTokenDelete(customerAccessToken: $customerAccessToken) {\n      userErrors {\n        ...FragmentUserError\n      }\n      deletedAccessToken\n      deletedCustomerAccessTokenId\n    }\n  }\n\n  ", "\n"]);

  _templateObject$g = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerAccessTokenDelete = gql(_templateObject$g(), FragmentUserError);

function _templateObject$h() {
  var data = _taggedTemplateLiteral(["\n  mutation($customerAccessToken: String!) {\n    customerAccessTokenRenew(customerAccessToken: $customerAccessToken) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customerAccessToken {\n        ...FragmentCustomerAccessToken\n      }\n    }\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$h = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerAccessTokenRenew = gql(_templateObject$h(), FragmentCustomerAccessToken, FragmentUserError);

function _templateObject$i() {
  var data = _taggedTemplateLiteral(["\n  fragment FragmentCheckoutUserError on CheckoutUserError {\n    field\n    message\n    code\n  }\n"]);

  _templateObject$i = function _templateObject() {
    return data;
  };

  return data;
}
var FragmentCheckoutUserError = gql(_templateObject$i());

function _templateObject$j() {
  var data = _taggedTemplateLiteral(["\n  mutation checkoutAttributesUpdateV2(\n    $checkoutId: ID!\n    $input: CheckoutAttributesUpdateV2Input!\n  ) {\n    checkoutAttributesUpdateV2(checkoutId: $checkoutId, input: $input) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkoutUserErrors {\n        ...FragmentCheckoutUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$j = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutAttributesUpdateV2 = gql(_templateObject$j(), FragmentCheckout, FragmentCheckoutUserError, FragmentUserError);

function _templateObject$k() {
  var data = _taggedTemplateLiteral(["\n  mutation($input: CheckoutCreateInput!) {\n    checkoutCreate(input: $input) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkoutUserErrors {\n        ...FragmentCheckoutUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$k = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutCreate = gql(_templateObject$k(), FragmentCheckout, FragmentCheckoutUserError, FragmentUserError);

function _templateObject$l() {
  var data = _taggedTemplateLiteral(["\n  mutation mutationCheckoutCustomerAssociateV2(\n    $checkoutId: ID!\n    $customerAccessToken: String!\n  ) {\n    checkoutCustomerAssociateV2(\n      checkoutId: $checkoutId\n      customerAccessToken: $customerAccessToken\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkoutUserErrors {\n        ...FragmentCheckoutUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n      customer {\n        ...FragmentCustomer\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$l = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutCustomerAssociateV2 = gql(_templateObject$l(), FragmentCheckoutUserError, FragmentCheckout, FragmentCustomer, FragmentUserError);

function _templateObject$m() {
  var data = _taggedTemplateLiteral(["\n  mutation mutationCheckoutCustomerDisassociateV2($checkoutId: ID!) {\n    checkoutCustomerDisassociateV2(\n      checkoutId: $checkoutId\n      customerAccessToken: $customerAccessToken\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkoutUserErrors {\n        ...FragmentCheckoutUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$m = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutCustomerDisassociateV2 = gql(_templateObject$m(), FragmentCheckoutUserError, FragmentCheckout, FragmentUserError);

function _templateObject$n() {
  var data = _taggedTemplateLiteral(["\n  mutation checkoutDiscountCodeApplyV2(\n    $discountCode: String!\n    $checkoutId: ID!\n  ) {\n    checkoutDiscountCodeApplyV2(\n      discountCode: $discountCode\n      checkoutId: $checkoutId\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkoutUserErrors {\n        ...FragmentCheckoutUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$n = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutDiscountCodeApplyV2 = gql(_templateObject$n(), FragmentCheckoutUserError, FragmentCheckout, FragmentUserError);

function _templateObject$o() {
  var data = _taggedTemplateLiteral(["\n  mutation checkoutDiscountCodeRemove($checkoutId: ID!) {\n    checkoutDiscountCodeRemove(checkoutId: $checkoutId) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkoutUserErrors {\n        ...FragmentCheckoutUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$o = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutDiscountCodeRemove = gql(_templateObject$o(), FragmentCheckout, FragmentCheckoutUserError, FragmentUserError);

function _templateObject$p() {
  var data = _taggedTemplateLiteral(["\n  mutation checkoutEmailUpdateV2($checkoutId: ID!, $email: String!) {\n    checkoutEmailUpdateV2(checkoutId: $checkoutId, email: $email) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkoutUserErrors {\n        ...FragmentCheckoutUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$p = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutEmailUpdateV2 = gql(_templateObject$p(), FragmentCheckout, FragmentCheckoutUserError, FragmentUserError);

function _templateObject$q() {
  var data = _taggedTemplateLiteral(["\n  mutation checkoutGiftCardRemoveV2(\n    $checkoutId: ID!\n    $appliedGiftCardId: [String!]!\n  ) {\n    checkoutGiftCardRemoveV2(\n      checkoutId: $checkoutId\n      appliedGiftCardId: $appliedGiftCardId\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$q = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutGiftCardRemoveV2 = gql(_templateObject$q(), FragmentCheckout, FragmentUserError);

function _templateObject$r() {
  var data = _taggedTemplateLiteral(["\n  mutation checkoutGiftCardsAppend(\n    $checkoutId: ID!\n    $giftCardCodes: [String!]!\n  ) {\n    checkoutGiftCardsAppend(\n      checkoutId: $checkoutId\n      giftCardCodes: $giftCardCodes\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$r = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutGiftCardsAppend = gql(_templateObject$r(), FragmentCheckout, FragmentUserError);

function _templateObject$s() {
  var data = _taggedTemplateLiteral(["\n  mutation($checkoutId: ID!, $lineItems: [CheckoutLineItemInput!]!) {\n    checkoutLineItemsReplace(checkoutId: $checkoutId, lineItems: $lineItems) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$s = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutLineItemsReplace = gql(_templateObject$s(), FragmentCheckout, FragmentUserError);

function _templateObject$t() {
  var data = _taggedTemplateLiteral(["\n  mutation($checkoutId: ID!, $shippingAddress: MailingAddressInput!) {\n    checkoutShippingAddressUpdateV2(\n      checkoutId: $checkoutId\n      shippingAddress: $shippingAddress\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$t = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutShippingAddressUpdateV2 = gql(_templateObject$t(), FragmentCheckout, FragmentUserError);

function _templateObject$u() {
  var data = _taggedTemplateLiteral(["\n  mutation($checkoutId: ID!, $shippingRateHandle: String!) {\n    checkoutShippingLineUpdate(\n      checkoutId: $checkoutId\n      shippingRateHandle: $shippingRateHandle\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      checkout {\n        ...FragmentCheckout\n      }\n    }\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$u = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCheckoutShippingLineUpdate = gql(_templateObject$u(), FragmentCheckout, FragmentUserError);

function _templateObject$v() {
  var data = _taggedTemplateLiteral(["\n  mutation($id: ID!, $input: CustomerActivateInput!) {\n    customerActivate(id: $id, input: $input) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customer {\n        ...FragmentCustomer\n      }\n      customerAccessToken {\n        ...FragmentCustomerAccessToken\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$v = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerActivate = gql(_templateObject$v(), FragmentCustomerAccessToken, FragmentCustomerUserError, FragmentCustomer, FragmentUserError);

function _templateObject$w() {
  var data = _taggedTemplateLiteral(["\n  mutation customerAddressCreate(\n    $customerAccessToken: String!\n    $address: MailingAddressInput!\n  ) {\n    customerAddressCreate(\n      customerAccessToken: $customerAccessToken\n      address: $address\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customerAddress {\n        ...FragmentMailingAddress\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$w = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerAddressCreate = gql(_templateObject$w(), FragmentCustomerUserError, FragmentMailingAddress, FragmentUserError);

function _templateObject$x() {
  var data = _taggedTemplateLiteral(["\n  mutation customerAddressDelete($id: ID!, $customerAccessToken: String!) {\n    customerAddressDelete(id: $id, customerAccessToken: $customerAccessToken) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n      deletedCustomerAddressId\n    }\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$x = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerAddressDelete = gql(_templateObject$x(), FragmentCustomerUserError, FragmentUserError);

function _templateObject$y() {
  var data = _taggedTemplateLiteral(["\n  mutation customerAddressUpdate(\n    $customerAccessToken: String!\n    $id: ID!\n    $address: MailingAddressInput!\n  ) {\n    customerAddressUpdate(\n      customerAccessToken: $customerAccessToken\n      id: $id\n      address: $address\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customerAddress {\n        ...FragmentMailingAddress\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$y = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerAddressUpdate = gql(_templateObject$y(), FragmentCustomerUserError, FragmentMailingAddress, FragmentUserError);

function _templateObject$z() {
  var data = _taggedTemplateLiteral(["\n  mutation customerCreate($input: CustomerCreateInput!) {\n    customerCreate(input: $input) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customer {\n        ...FragmentCustomer\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$z = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerCreate = gql(_templateObject$z(), FragmentCustomerUserError, FragmentCustomer, FragmentUserError);

function _templateObject$A() {
  var data = _taggedTemplateLiteral(["\n  mutation customerDefaultAddressUpdate(\n    $customerAccessToken: String!\n    $addressId: ID!\n  ) {\n    customerDefaultAddressUpdate(\n      customerAccessToken: $customerAccessToken\n      addressId: $addressId\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customer {\n        ...FragmentCustomer\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$A = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerDefaultAddressUpdate = gql(_templateObject$A(), FragmentCustomerUserError, FragmentCustomer, FragmentUserError);

function _templateObject$B() {
  var data = _taggedTemplateLiteral(["\n  mutation customerRecover($email: String!) {\n    customerRecover(email: $email) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n"]);

  _templateObject$B = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerRecover = gql(_templateObject$B(), FragmentCustomerUserError, FragmentUserError);

function _templateObject$C() {
  var data = _taggedTemplateLiteral(["\n  mutation customerReset($id: ID!, $input: CustomerResetInput!) {\n    customerReset(id: $id, input: $input) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customer {\n        ...FragmentCustomer\n      }\n      customerAccessToken {\n        ...FragmentCustomerAccessToken\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$C = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerReset = gql(_templateObject$C(), FragmentCustomerAccessToken, FragmentCustomerUserError, FragmentCustomer, FragmentUserError);

function _templateObject$D() {
  var data = _taggedTemplateLiteral(["\n  mutation customerResetByUrl($resetUrl: URL!, $password: String!) {\n    customerResetByUrl(resetUrl: $resetUrl, password: $password) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customer {\n        ...FragmentCustomer\n      }\n      customerAccessToken {\n        ...FragmentCustomerAccessToken\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$D = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerResetByUrl = gql(_templateObject$D(), FragmentCustomerAccessToken, FragmentCustomerUserError, FragmentCustomer, FragmentUserError);

function _templateObject$E() {
  var data = _taggedTemplateLiteral(["\n  mutation customerUpdate(\n    $customerAccessToken: String!\n    $customer: CustomerUpdateInput!\n  ) {\n    customerUpdate(\n      customerAccessToken: $customerAccessToken\n      customer: $customer\n    ) {\n      userErrors {\n        ...FragmentUserError\n      }\n      customer {\n        ...FragmentCustomer\n      }\n      customerAccessToken {\n        ...FragmentCustomerAccessToken\n      }\n      customerUserErrors {\n        ...FragmentCustomerUserError\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject$E = function _templateObject() {
    return data;
  };

  return data;
}
var MutationCustomerUpdate = gql(_templateObject$E(), FragmentCustomerAccessToken, FragmentCustomerUserError, FragmentCustomer, FragmentUserError);

/***
 * ShopifyProvider
 *
 * Root context provider to allow Apollo to communicate with Shopify.
 */

var ShopifyProvider = function ShopifyProvider(_ref) {
  var children = _ref.children,
      client = _ref.client,
      shopName = _ref.shopName,
      storefrontAccessToken = _ref.storefrontAccessToken;
  if (!client) client = new ApolloClient({
    uri: "https://".concat(shopName, ".myshopify.com/api/graphql"),
    headers: {
      'X-Shopify-Storefront-Access-Token': storefrontAccessToken
    }
  });
  return React.createElement(ApolloProvider, {
    client: client
  }, children);
};
/***
 * useShopifyProduct
 *
 * Provides product data for a given product ID.
 */

var useShopifyProduct = function useShopifyProduct(id) {
  var _useQuery = useQuery(QueryProductNode, {
    variables: {
      id: id
    },
    suspend: false
  }),
      data = _useQuery.data,
      rest = _objectWithoutProperties(_useQuery, ["data"]);

  return _objectSpread({
    product: _get('node', data)
  }, rest);
};
/***
 * useShopifyProductVariant
 *
 * Provides product variant data for a given variant ID.
 */

var useShopifyProductVariant = function useShopifyProductVariant(id) {
  var _useQuery2 = useQuery(QueryProductVariantNode, {
    variables: {
      id: id
    },
    suspend: false
  }),
      data = _useQuery2.data,
      rest = _objectWithoutProperties(_useQuery2, ["data"]);

  return _objectSpread({
    productVariant: _get('node', data)
  }, rest);
};
/***
 * useShopifyCustomerAccessToken
 *
 * Manages customer access token creation, renewal, and deletion.
 */

var useShopifyCustomerAccessToken = function useShopifyCustomerAccessToken() {
  var mutationCustomerAccessTokenCreate = useMutation(MutationCustomerAccessTokenCreate);
  var mutationCustomerAccessTokenRenew = useMutation(MutationCustomerAccessTokenRenew);
  var mutationCustomerAccessTokenDelete = useMutation(MutationCustomerAccessTokenDelete);
  return {
    // Create a new customer access token. Returns the token.
    createCustomerAccessToken: function () {
      var _createCustomerAccessToken = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(email, password) {
        var result;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return mutationCustomerAccessTokenCreate({
                  variables: {
                    input: {
                      email: email,
                      password: password
                    }
                  }
                });

              case 2:
                result = _context.sent;
                return _context.abrupt("return", mutationResultNormalizer('customerAccessTokenCreate', 'customerAccessToken', result));

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function createCustomerAccessToken(_x, _x2) {
        return _createCustomerAccessToken.apply(this, arguments);
      }

      return createCustomerAccessToken;
    }(),
    // Renew the customer access token. Returns the renewed token.
    renewCustomerAccessToken: function () {
      var _renewCustomerAccessToken = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(customerAccessToken) {
        var result;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return mutationCustomerAccessTokenRenew({
                  variables: {
                    customerAccessToken: customerAccessToken
                  }
                });

              case 2:
                result = _context2.sent;
                return _context2.abrupt("return", mutationResultNormalizer('customerAccessTokenRenew', 'customerAccessToken', result));

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function renewCustomerAccessToken(_x3) {
        return _renewCustomerAccessToken.apply(this, arguments);
      }

      return renewCustomerAccessToken;
    }(),
    // Permanently delete the customer access token.
    deleteCustomerAccessToken: function () {
      var _deleteCustomerAccessToken = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(customerAccessToken) {
        var result;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return mutationCustomerAccessTokenDelete({
                  variables: {
                    customerAccessToken: customerAccessToken
                  }
                });

              case 2:
                result = _context3.sent;
                return _context3.abrupt("return", mutationResultNormalizer('customerAccessTokenDelete', 'deletedAccessToken', result));

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function deleteCustomerAccessToken(_x4) {
        return _deleteCustomerAccessToken.apply(this, arguments);
      }

      return deleteCustomerAccessToken;
    }()
  };
};
/***
 * useShopifyCheckout
 *
 * Fetches a checkout using the provided checkout ID and provides actions for
 * that checkout.
 */

var useShopifyCheckout = function useShopifyCheckout(checkoutId) {
  var _useQuery3 = useQuery(QueryCheckoutNode, {
    variables: {
      id: checkoutId
    },
    skip: !checkoutId,
    suspend: false
  }),
      data = _useQuery3.data,
      rest = _objectWithoutProperties(_useQuery3, ["data"]); // Mutations


  var mutationCheckoutCreate = useMutation(MutationCheckoutCreate);
  var mutationCheckoutAttributesUpdateV2 = useMutation(MutationCheckoutAttributesUpdateV2);
  var mutationCheckoutCustomerAssociateV2 = useMutation(MutationCheckoutCustomerAssociateV2);
  var mutationCheckoutCustomerDisassociateV2 = useMutation(MutationCheckoutCustomerDisassociateV2);
  var mutationCheckoutDiscountCodeApplyV2 = useMutation(MutationCheckoutDiscountCodeApplyV2);
  var mutationCheckoutDiscountCodeRemove = useMutation(MutationCheckoutDiscountCodeRemove);
  var mutationCheckoutEmailUpdateV2 = useMutation(MutationCheckoutEmailUpdateV2);
  var mutationCheckoutGiftCardsAppend = useMutation(MutationCheckoutGiftCardsAppend);
  var mutationCheckoutGiftCardRemoveV2 = useMutation(MutationCheckoutGiftCardRemoveV2);
  var mutationCheckoutLineItemsReplace = useMutation(MutationCheckoutLineItemsReplace);
  var mutationCheckoutShippingAddressUpdateV2 = useMutation(MutationCheckoutShippingAddressUpdateV2);
  var mutationCheckoutShippingLineUpdate = useMutation(MutationCheckoutShippingLineUpdate);
  return _objectSpread({
    // All checkout data. Data updates on successful actions.
    checkout: _get('node', data)
  }, rest, {
    // Collection of functions related to the product variant.
    actions: {
      // Create a new checkout.
      createCheckout: function () {
        var _createCheckout = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee4() {
          var input,
              result,
              _args4 = arguments;
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  input = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : {};
                  _context4.next = 3;
                  return mutationCheckoutCreate({
                    variables: {
                      input: input
                    }
                  });

                case 3:
                  result = _context4.sent;
                  return _context4.abrupt("return", mutationResultNormalizer('checkoutCreate', 'checkout', result));

                case 5:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        }));

        function createCheckout() {
          return _createCheckout.apply(this, arguments);
        }

        return createCheckout;
      }(),
      // Update the checkout attributes.
      attributesUpdate: function () {
        var _attributesUpdate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee5(input) {
          var result;
          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  _context5.next = 2;
                  return mutationCheckoutAttributesUpdateV2({
                    variables: {
                      checkoutId: checkoutId,
                      input: input
                    }
                  });

                case 2:
                  result = _context5.sent;
                  return _context5.abrupt("return", mutationResultNormalizer('checkoutAttributesUpdateV2', 'checkout', result));

                case 4:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5);
        }));

        function attributesUpdate(_x5) {
          return _attributesUpdate.apply(this, arguments);
        }

        return attributesUpdate;
      }(),
      // Associate the checkout to a customer.
      customerAssociate: function () {
        var _customerAssociate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee6(customerAccessToken) {
          var result;
          return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  _context6.next = 2;
                  return mutationCheckoutCustomerAssociateV2({
                    variables: {
                      checkoutId: checkoutId,
                      customerAccessToken: customerAccessToken
                    }
                  });

                case 2:
                  result = _context6.sent;
                  return _context6.abrupt("return", mutationResultNormalizer('checkoutCustomerAssociateV2', 'checkout', result));

                case 4:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6);
        }));

        function customerAssociate(_x6) {
          return _customerAssociate.apply(this, arguments);
        }

        return customerAssociate;
      }(),
      // Disssociate the checkout from any customer.
      customerDisassociate: function () {
        var _customerDisassociate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee7() {
          var result;
          return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  _context7.next = 2;
                  return mutationCheckoutCustomerDisassociateV2({
                    variables: {
                      checkoutId: checkoutId
                    }
                  });

                case 2:
                  result = _context7.sent;
                  return _context7.abrupt("return", mutationResultNormalizer('checkoutCustomerDisassociateV2', 'checkout', result));

                case 4:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee7);
        }));

        function customerDisassociate() {
          return _customerDisassociate.apply(this, arguments);
        }

        return customerDisassociate;
      }(),
      // Apply a discount code to the checkout.
      discountCodeApply: function () {
        var _discountCodeApply = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee8(discountCode) {
          var result;
          return regeneratorRuntime.wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  _context8.next = 2;
                  return mutationCheckoutDiscountCodeApplyV2({
                    variables: {
                      checkoutId: checkoutId,
                      discountCode: discountCode
                    }
                  });

                case 2:
                  result = _context8.sent;
                  return _context8.abrupt("return", mutationResultNormalizer('checkoutDiscountCodeApplyV2', 'checkout', result));

                case 4:
                case "end":
                  return _context8.stop();
              }
            }
          }, _callee8);
        }));

        function discountCodeApply(_x7) {
          return _discountCodeApply.apply(this, arguments);
        }

        return discountCodeApply;
      }(),
      // Remove any discount code from the checkout.
      discountCodeRemove: function () {
        var _discountCodeRemove = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee9() {
          var result;
          return regeneratorRuntime.wrap(function _callee9$(_context9) {
            while (1) {
              switch (_context9.prev = _context9.next) {
                case 0:
                  _context9.next = 2;
                  return mutationCheckoutDiscountCodeRemove({
                    variables: {
                      checkoutId: checkoutId
                    }
                  });

                case 2:
                  result = _context9.sent;
                  return _context9.abrupt("return", mutationResultNormalizer('checkoutDiscountCodeRemove', 'checkout', result));

                case 4:
                case "end":
                  return _context9.stop();
              }
            }
          }, _callee9);
        }));

        function discountCodeRemove() {
          return _discountCodeRemove.apply(this, arguments);
        }

        return discountCodeRemove;
      }(),
      // Update the checkout's email address.
      emailUpdate: function () {
        var _emailUpdate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee10(email) {
          var result;
          return regeneratorRuntime.wrap(function _callee10$(_context10) {
            while (1) {
              switch (_context10.prev = _context10.next) {
                case 0:
                  _context10.next = 2;
                  return mutationCheckoutEmailUpdateV2({
                    variables: {
                      checkoutId: checkoutId,
                      email: email
                    }
                  });

                case 2:
                  result = _context10.sent;
                  return _context10.abrupt("return", mutationResultNormalizer('checkoutEmailUpdateV2', 'checkout', result));

                case 4:
                case "end":
                  return _context10.stop();
              }
            }
          }, _callee10);
        }));

        function emailUpdate(_x8) {
          return _emailUpdate.apply(this, arguments);
        }

        return emailUpdate;
      }(),
      // Append gift card codes to the checkout.
      giftCardsAppend: function () {
        var _giftCardsAppend = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee11(giftCardCodes) {
          var result;
          return regeneratorRuntime.wrap(function _callee11$(_context11) {
            while (1) {
              switch (_context11.prev = _context11.next) {
                case 0:
                  _context11.next = 2;
                  return mutationCheckoutGiftCardsAppend({
                    variables: {
                      checkoutId: checkoutId,
                      giftCardCodes: giftCardCodes
                    }
                  });

                case 2:
                  result = _context11.sent;
                  return _context11.abrupt("return", mutationResultNormalizer('checkoutGiftCardsAppend', 'checkout', result));

                case 4:
                case "end":
                  return _context11.stop();
              }
            }
          }, _callee11);
        }));

        function giftCardsAppend(_x9) {
          return _giftCardsAppend.apply(this, arguments);
        }

        return giftCardsAppend;
      }(),
      // Remove the gift card code from the checkout.
      giftCardRemove: function () {
        var _giftCardRemove = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee12(appliedGiftCardId) {
          var result;
          return regeneratorRuntime.wrap(function _callee12$(_context12) {
            while (1) {
              switch (_context12.prev = _context12.next) {
                case 0:
                  _context12.next = 2;
                  return mutationCheckoutGiftCardRemoveV2({
                    variables: {
                      checkoutId: checkoutId,
                      appliedGiftCardId: appliedGiftCardId
                    }
                  });

                case 2:
                  result = _context12.sent;
                  return _context12.abrupt("return", mutationResultNormalizer('checkoutGiftCardRemoveV2', 'checkout', result));

                case 4:
                case "end":
                  return _context12.stop();
              }
            }
          }, _callee12);
        }));

        function giftCardRemove(_x10) {
          return _giftCardRemove.apply(this, arguments);
        }

        return giftCardRemove;
      }(),
      // Replace the checkout line items.
      lineItemsReplace: function () {
        var _lineItemsReplace = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee13(lineItems) {
          var result;
          return regeneratorRuntime.wrap(function _callee13$(_context13) {
            while (1) {
              switch (_context13.prev = _context13.next) {
                case 0:
                  _context13.next = 2;
                  return mutationCheckoutLineItemsReplace({
                    variables: {
                      checkoutId: checkoutId,
                      lineItems: lineItems
                    }
                  });

                case 2:
                  result = _context13.sent;
                  return _context13.abrupt("return", mutationResultNormalizer('checkoutLineItemsReplace', 'checkout', result));

                case 4:
                case "end":
                  return _context13.stop();
              }
            }
          }, _callee13);
        }));

        function lineItemsReplace(_x11) {
          return _lineItemsReplace.apply(this, arguments);
        }

        return lineItemsReplace;
      }(),
      // Update the checkout's shipping address.
      shippingAddressUpdate: function () {
        var _shippingAddressUpdate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee14(shippingAddress) {
          var result;
          return regeneratorRuntime.wrap(function _callee14$(_context14) {
            while (1) {
              switch (_context14.prev = _context14.next) {
                case 0:
                  _context14.next = 2;
                  return mutationCheckoutShippingAddressUpdateV2({
                    variables: {
                      checkoutId: checkoutId,
                      shippingAddress: shippingAddress
                    }
                  });

                case 2:
                  result = _context14.sent;
                  return _context14.abrupt("return", mutationResultNormalizer('checkoutShippingAddressUpdateV2', 'checkout', result));

                case 4:
                case "end":
                  return _context14.stop();
              }
            }
          }, _callee14);
        }));

        function shippingAddressUpdate(_x12) {
          return _shippingAddressUpdate.apply(this, arguments);
        }

        return shippingAddressUpdate;
      }(),
      // Update the checkout's shipping line.
      shippingLineUpdate: function () {
        var _shippingLineUpdate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee15(shippingRateHandle) {
          var result;
          return regeneratorRuntime.wrap(function _callee15$(_context15) {
            while (1) {
              switch (_context15.prev = _context15.next) {
                case 0:
                  _context15.next = 2;
                  return mutationCheckoutShippingLineUpdate({
                    variables: {
                      checkoutId: checkoutId,
                      shippingRateHandle: shippingRateHandle
                    }
                  });

                case 2:
                  result = _context15.sent;
                  return _context15.abrupt("return", mutationResultNormalizer('checkoutShippingLineUpdate', 'checkout', result));

                case 4:
                case "end":
                  return _context15.stop();
              }
            }
          }, _callee15);
        }));

        function shippingLineUpdate(_x13) {
          return _shippingLineUpdate.apply(this, arguments);
        }

        return shippingLineUpdate;
      }()
    }
  });
};
/***
 * useShopifyCustomer
 *
 * Fetches a customer using the provided customer access token and provides
 * actions for that customer.
 */

var useShopifyCustomer = function useShopifyCustomer(customerAccessToken) {
  // Nodes
  var _useQuery4 = useQuery(QueryCustomer, {
    variables: {
      customerAccessToken: customerAccessToken
    },
    skip: !Boolean(customerAccessToken),
    suspend: false
  }),
      data = _useQuery4.data,
      rest = _objectWithoutProperties(_useQuery4, ["data"]); // Mutations


  var mutationCustomerActivate = useMutation(MutationCustomerActivate);
  var mutationCustomerAddressCreate = useMutation(MutationCustomerAddressCreate);
  var mutationCustomerAddressDelete = useMutation(MutationCustomerAddressDelete);
  var mutationCustomerAddressUpdate = useMutation(MutationCustomerAddressUpdate);
  var mutationCustomerCreate = useMutation(MutationCustomerCreate);
  var mutationCustomerDefaultAddressUpdate = useMutation(MutationCustomerDefaultAddressUpdate);
  var mutationCustomerRecover = useMutation(MutationCustomerRecover);
  var mutationCustomerReset = useMutation(MutationCustomerReset);
  var mutationCustomerResetByUrl = useMutation(MutationCustomerResetByUrl);
  var mutationCustomerUpdate = useMutation(MutationCustomerUpdate);
  return _objectSpread({
    // All customer data. Data updates on successful actions.
    customer: _get('customer', data)
  }, rest, {
    // Collection of functions related to the customer.
    actions: {
      // Create a new customer. Returns the customer
      createCustomer: function () {
        var _createCustomer = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee16(email, password) {
          var result;
          return regeneratorRuntime.wrap(function _callee16$(_context16) {
            while (1) {
              switch (_context16.prev = _context16.next) {
                case 0:
                  _context16.next = 2;
                  return mutationCustomerCreate({
                    variables: {
                      input: {
                        email: email,
                        password: password
                      }
                    }
                  });

                case 2:
                  result = _context16.sent;
                  return _context16.abrupt("return", mutationResultNormalizer('customerCreate', 'customer', result));

                case 4:
                case "end":
                  return _context16.stop();
              }
            }
          }, _callee16);
        }));

        function createCustomer(_x14, _x15) {
          return _createCustomer.apply(this, arguments);
        }

        return createCustomer;
      }(),
      // Activate a customer using the provided customer ID, activation token,
      // and password. Returns customer access token data.
      activateCustomer: function () {
        var _activateCustomer = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee17(id, activationToken, password) {
          var result;
          return regeneratorRuntime.wrap(function _callee17$(_context17) {
            while (1) {
              switch (_context17.prev = _context17.next) {
                case 0:
                  _context17.next = 2;
                  return mutationCustomerActivate({
                    variables: {
                      id: id,
                      input: {
                        activationToken: activationToken,
                        password: password
                      }
                    }
                  });

                case 2:
                  result = _context17.sent;
                  return _context17.abrupt("return", mutationResultNormalizer('customerActivate', 'customerAccessToken', result));

                case 4:
                case "end":
                  return _context17.stop();
              }
            }
          }, _callee17);
        }));

        function activateCustomer(_x16, _x17, _x18) {
          return _activateCustomer.apply(this, arguments);
        }

        return activateCustomer;
      }(),
      // Send a reset password email to the customer.
      recoverCustomer: function () {
        var _recoverCustomer = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee18(email) {
          var result;
          return regeneratorRuntime.wrap(function _callee18$(_context18) {
            while (1) {
              switch (_context18.prev = _context18.next) {
                case 0:
                  _context18.next = 2;
                  return mutationCustomerRecover({
                    variables: {
                      email: email
                    }
                  });

                case 2:
                  result = _context18.sent;
                  return _context18.abrupt("return", mutationResultNormalizer('customerRecover', false, result));

                case 4:
                case "end":
                  return _context18.stop();
              }
            }
          }, _callee18);
        }));

        function recoverCustomer(_x19) {
          return _recoverCustomer.apply(this, arguments);
        }

        return recoverCustomer;
      }(),
      // Reset a customer's password with the provided reset token and
      // password. Returns customer access token data.
      resetCustomer: function () {
        var _resetCustomer = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee19(id, resetToken, password) {
          var result;
          return regeneratorRuntime.wrap(function _callee19$(_context19) {
            while (1) {
              switch (_context19.prev = _context19.next) {
                case 0:
                  _context19.next = 2;
                  return mutationCustomerReset({
                    variables: {
                      id: id,
                      input: {
                        resetToken: resetToken,
                        password: password
                      }
                    }
                  });

                case 2:
                  result = _context19.sent;
                  return _context19.abrupt("return", mutationResultNormalizer('customerReset', 'customerAccessToken', result));

                case 4:
                case "end":
                  return _context19.stop();
              }
            }
          }, _callee19);
        }));

        function resetCustomer(_x20, _x21, _x22) {
          return _resetCustomer.apply(this, arguments);
        }

        return resetCustomer;
      }(),
      // Reset a customer's password with the provided reset URL and password.
      // Returns customer access token data.
      resetCustomerByUrl: function () {
        var _resetCustomerByUrl = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee20(resetUrl, password) {
          var result;
          return regeneratorRuntime.wrap(function _callee20$(_context20) {
            while (1) {
              switch (_context20.prev = _context20.next) {
                case 0:
                  _context20.next = 2;
                  return mutationCustomerResetByUrl({
                    variables: {
                      resetUrl: resetUrl,
                      password: password
                    }
                  });

                case 2:
                  result = _context20.sent;
                  return _context20.abrupt("return", mutationResultNormalizer('customerResetByUrl', 'customerAccessToken', result));

                case 4:
                case "end":
                  return _context20.stop();
              }
            }
          }, _callee20);
        }));

        function resetCustomerByUrl(_x23, _x24) {
          return _resetCustomerByUrl.apply(this, arguments);
        }

        return resetCustomerByUrl;
      }(),
      // Add an address to the customer.
      addressCreate: function () {
        var _addressCreate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee21(address) {
          var result;
          return regeneratorRuntime.wrap(function _callee21$(_context21) {
            while (1) {
              switch (_context21.prev = _context21.next) {
                case 0:
                  _context21.next = 2;
                  return mutationCustomerAddressCreate({
                    variables: {
                      customerAccessToken: customerAccessToken,
                      address: address
                    }
                  });

                case 2:
                  result = _context21.sent;
                  return _context21.abrupt("return", mutationResultNormalizer('customerAddressCreate', 'customerAddress', result));

                case 4:
                case "end":
                  return _context21.stop();
              }
            }
          }, _callee21);
        }));

        function addressCreate(_x25) {
          return _addressCreate.apply(this, arguments);
        }

        return addressCreate;
      }(),
      // Delete a customer's address using the address ID.
      addressDelete: function () {
        var _addressDelete = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee22(id) {
          var result;
          return regeneratorRuntime.wrap(function _callee22$(_context22) {
            while (1) {
              switch (_context22.prev = _context22.next) {
                case 0:
                  _context22.next = 2;
                  return mutationCustomerAddressDelete({
                    variables: {
                      customerAccessToken: customerAccessToken,
                      id: id
                    }
                  });

                case 2:
                  result = _context22.sent;
                  return _context22.abrupt("return", mutationResultNormalizer('customerAddressDelete', false, result));

                case 4:
                case "end":
                  return _context22.stop();
              }
            }
          }, _callee22);
        }));

        function addressDelete(_x26) {
          return _addressDelete.apply(this, arguments);
        }

        return addressDelete;
      }(),
      // Update a customer's address using the address ID.
      addressUpdate: function () {
        var _addressUpdate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee23(id, address) {
          var result;
          return regeneratorRuntime.wrap(function _callee23$(_context23) {
            while (1) {
              switch (_context23.prev = _context23.next) {
                case 0:
                  _context23.next = 2;
                  return mutationCustomerAddressUpdate({
                    variables: {
                      customerAccessToken: customerAccessToken,
                      id: id,
                      address: address
                    }
                  });

                case 2:
                  result = _context23.sent;
                  return _context23.abrupt("return", mutationResultNormalizer('customerAddressUpdate', 'customerAddress', result));

                case 4:
                case "end":
                  return _context23.stop();
              }
            }
          }, _callee23);
        }));

        function addressUpdate(_x27, _x28) {
          return _addressUpdate.apply(this, arguments);
        }

        return addressUpdate;
      }(),
      // Set a default address for the customer.
      addressDefaultAddressUpdate: function () {
        var _addressDefaultAddressUpdate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee24(addressId) {
          var result;
          return regeneratorRuntime.wrap(function _callee24$(_context24) {
            while (1) {
              switch (_context24.prev = _context24.next) {
                case 0:
                  _context24.next = 2;
                  return mutationCustomerDefaultAddressUpdate({
                    variables: {
                      customerAccessToken: customerAccessToken,
                      addressId: addressId
                    }
                  });

                case 2:
                  result = _context24.sent;
                  return _context24.abrupt("return", mutationResultNormalizer('customerDefaultAddressUpdate', 'customer', result));

                case 4:
                case "end":
                  return _context24.stop();
              }
            }
          }, _callee24);
        }));

        function addressDefaultAddressUpdate(_x29) {
          return _addressDefaultAddressUpdate.apply(this, arguments);
        }

        return addressDefaultAddressUpdate;
      }(),
      // Update a customer's attributes.
      updateCustomer: function () {
        var _updateCustomer = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee25(customer) {
          var result;
          return regeneratorRuntime.wrap(function _callee25$(_context25) {
            while (1) {
              switch (_context25.prev = _context25.next) {
                case 0:
                  _context25.next = 2;
                  return mutationCustomerUpdate({
                    variables: {
                      customerAccessToken: customerAccessToken,
                      customer: customer
                    }
                  });

                case 2:
                  result = _context25.sent;
                  return _context25.abrupt("return", mutationResultNormalizer('customerUpdate', 'customer', result));

                case 4:
                case "end":
                  return _context25.stop();
              }
            }
          }, _callee25);
        }));

        function updateCustomer(_x30) {
          return _updateCustomer.apply(this, arguments);
        }

        return updateCustomer;
      }()
    }
  });
};

// Returns an array of nodes from the connection data provided as a result of a
// GraphQL query.
var getNodes = _compose(_map('node'), _get('edges'));

var initialState = {
  customerAccessToken: null,
  customerAccessTokenExpiresAt: null,
  checkoutId: null,
  checkoutLineItems: []
};

var reducer = function reducer(state, action) {
  var type = action.type,
      payload = action.payload;

  switch (type) {
    case 'SET_CUSTOMER_ACCESS_TOKEN':
      return _objectSpread({}, state, {
        customerAccessToken: payload.accessToken,
        customerAccessTokenExpiresAt: payload.expiresAt
      });

    case 'SET_CHECKOUT_ID':
      return _objectSpread({}, state, {
        checkoutId: payload
      });

    case 'SET_CHECKOUT_LINE_ITEMS':
      return _objectSpread({}, state, {
        checkoutLineItems: payload
      });

    case 'RESET':
      return initialState;

    default:
      throw new Error('Invalid action type. Please use a supported action.');
  }
};

var ReducerContext = React.createContext();

var ReducerProvider = function ReducerProvider(_ref) {
  var children = _ref.children,
      _ref$persist = _ref.persist;
  var hookedReducer = useReducer(reducer, initialState);
  return React.createElement(ReducerContext.Provider, {
    value: hookedReducer
  }, children);
};
/***
 * ShopifyProviderWithContext
 *
 * Root context provider to allow Apollo to communicate with Shopify and store
 * global state.
 */


var ShopifyProviderWithContext = function ShopifyProviderWithContext(_ref2) {
  var _ref2$persist = _ref2.persist,
      persist = _ref2$persist === void 0 ? true : _ref2$persist,
      props = _objectWithoutProperties(_ref2, ["persist"]);

  return React.createElement(ReducerProvider, {
    persist: persist
  }, React.createElement(ShopifyProvider, props));
};
/***
 * useShopifyReducer
 *
 * Returns the reducer used for managing global state.
 */

var useShopifyReducer = function useShopifyReducer() {
  return useContext(ReducerContext);
};
/***
 * useShopifyCustomerAccessTokenWithContext
 *
 * useShopifyCustomerAccessToken hooked up to global state. Customer access
 * tokens are stored in the global state to allow implicit access to the token
 * in other hooks.
 *
 * If autoRenew is true, this hook will automatically renew the token if the
 * saved token expires within 1 day.
 */

var useShopifyCustomerAccessTokenWithContext = function useShopifyCustomerAccessTokenWithContext() {

  var _useShopifyReducer = useShopifyReducer(),
      _useShopifyReducer2 = _slicedToArray(_useShopifyReducer, 2),
      customerAccessToken = _useShopifyReducer2[0].customerAccessToken,
      dispatch = _useShopifyReducer2[1];

  var useShopifyCustomerAccessTokenResult = useShopifyCustomerAccessToken(customerAccessToken);
  var createCustomerAccessToken = useShopifyCustomerAccessTokenResult.createCustomerAccessToken,
      renewCustomerAccessToken = useShopifyCustomerAccessTokenResult.renewCustomerAccessToken,
      deleteCustomerAccessToken = useShopifyCustomerAccessTokenResult.deleteCustomerAccessToken; // Renews and sets the global customer access token.

  var renewToken =
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var result, _result$data, accessToken, expiresAt;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return renewCustomerAccessToken(customerAccessToken);

            case 2:
              result = _context.sent;

              if (result.data) {
                _result$data = result.data, accessToken = _result$data.accessToken, expiresAt = _result$data.expiresAt;
                dispatch({
                  type: 'SET_CUSTOMER_ACCESS_TOKEN',
                  payload: {
                    accessToken: accessToken,
                    expiresAt: expiresAt
                  }
                });
              }

              return _context.abrupt("return", result);

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function renewToken() {
      return _ref3.apply(this, arguments);
    };
  }(); // TODO: Add auto-renew logic here.
  // - If wihin 1 day (duration undecided) of expiration, renew token


  return _merge(useShopifyCustomerAccessTokenResult, {
    customerAccessToken: customerAccessToken,
    isSignedIn: Boolean(customerAccessToken),
    actions: {
      // Creates and sets the global customer access token.
      signIn: function () {
        var _signIn = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee2() {
          var result,
              _result$data2,
              accessToken,
              expiresAt,
              _args2 = arguments;

          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return createCustomerAccessToken.apply(void 0, _args2);

                case 2:
                  result = _context2.sent;

                  if (result.data) {
                    _result$data2 = result.data, accessToken = _result$data2.accessToken, expiresAt = _result$data2.expiresAt;
                    dispatch({
                      type: 'SET_CUSTOMER_ACCESS_TOKEN',
                      payload: {
                        accessToken: accessToken,
                        expiresAt: expiresAt
                      }
                    });
                  }

                  return _context2.abrupt("return", result);

                case 5:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        function signIn() {
          return _signIn.apply(this, arguments);
        }

        return signIn;
      }(),
      // Renews and sets the global customer access token.
      renewToken: renewToken,
      // Deletes the global customer access token and resets the global state.
      signOut: function () {
        var _signOut = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee3() {
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  if (customerAccessToken) deleteCustomerAccessToken(customerAccessToken);
                  dispatch({
                    type: 'RESET'
                  });

                case 2:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        }));

        function signOut() {
          return _signOut.apply(this, arguments);
        }

        return signOut;
      }()
    }
  });
};
/***
 * useShopifyCheckoutWithContext
 *
 * useShopifyCheckout hooked up to global state. A single checkout is stored
 * globally to allow implicit access to the checkout in other hooks.
 */

var useShopifyCheckoutWithContext = function useShopifyCheckoutWithContext() {
  var autoCreate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

  var _useShopifyReducer3 = useShopifyReducer(),
      _useShopifyReducer4 = _slicedToArray(_useShopifyReducer3, 2),
      checkoutId = _useShopifyReducer4[0].checkoutId,
      dispatch = _useShopifyReducer4[1];

  var useShopifyCheckoutResult = useShopifyCheckout(checkoutId);
  var createCheckout = useShopifyCheckoutResult.actions.createCheckout; // Creates and sets a new global checkout.

  var createCheckoutWithContext =
  /*#__PURE__*/
  function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4() {
      var result,
          id,
          _args4 = arguments;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return createCheckout.apply(void 0, _args4);

            case 2:
              result = _context4.sent;

              if (result.data) {
                id = result.data.id;
                dispatch({
                  type: 'SET_CHECKOUT_ID',
                  payload: id
                });
              }

              return _context4.abrupt("return", result);

            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function createCheckoutWithContext() {
      return _ref4.apply(this, arguments);
    };
  }(); // If autoCreate is true, automatically create a new checkout if one is not
  // present.


  useEffect(function () {
    if (autoCreate && !checkoutId) createCheckoutWithContext();
  }, [checkoutId]);
  return _merge(useShopifyCheckoutResult, {
    actions: {
      // Creates and sets a new global checkout.
      createCheckout: createCheckoutWithContext
    }
  });
};
/***
 * useShopifyProductVariantWithContext
 *
 * useShopifyCheckout hooked up to global state. This provides convenient
 * global checkout-related functions.
 */

var useShopifyProductVariantWithContext = function useShopifyProductVariantWithContext(variantId) {
  var _useShopifyReducer5 = useShopifyReducer(),
      _useShopifyReducer6 = _slicedToArray(_useShopifyReducer5, 2),
      checkoutLineItems = _useShopifyReducer6[0].checkoutLineItems,
      dispatch = _useShopifyReducer6[1];

  var useShopifyProductVariantResult = useShopifyProductVariant(variantId);

  var _useShopifyCheckoutWi = useShopifyCheckoutWithContext(),
      lineItemsReplace = _useShopifyCheckoutWi.actions.lineItemsReplace;

  return _merge(useShopifyProductVariantResult, {
    actions: {
      // Adds the product variant to the global checkout.
      addToCheckout: function () {
        var _addToCheckout = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee5() {
          var quantity,
              customAttributes,
              newLineItem,
              mergedLineItems,
              checkout,
              lineItems,
              _args5 = arguments;
          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  quantity = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : 1;
                  customAttributes = _args5.length > 1 ? _args5[1] : undefined;
                  // TODO: Need a proper merge w/ quantity checking
                  newLineItem = {
                    variantId: variantId,
                    quantity: quantity,
                    customAttributes: customAttributes
                  };
                  mergedLineItems = [].concat(_toConsumableArray(checkoutLineItems), [newLineItem]);
                  _context5.next = 6;
                  return lineItemsReplace(mergedLineItems);

                case 6:
                  checkout = _context5.sent;
                  lineItems = _compose(getNodes, _get('data.lineItems'))(checkout);
                  dispatch({
                    type: 'SET_CHECKOUT_LINE_ITEMS',
                    payload: lineItems
                  });

                case 9:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5);
        }));

        function addToCheckout() {
          return _addToCheckout.apply(this, arguments);
        }

        return addToCheckout;
      }()
    }
  });
};
/***
 * useShopifyCustomerWithContext
 *
 * useShopifyCustomer hooked up to global state.
 */

var useShopifyCustomerWithContext = function useShopifyCustomerWithContext() {
  var _useShopifyReducer7 = useShopifyReducer(),
      _useShopifyReducer8 = _slicedToArray(_useShopifyReducer7, 2),
      customerAccessToken = _useShopifyReducer8[0].customerAccessToken,
      dispatch = _useShopifyReducer8[1];

  var useShopifyCustomerResult = useShopifyCustomer(customerAccessToken);
  var _useShopifyCustomerRe = useShopifyCustomerResult.actions,
      _activateCustomer = _useShopifyCustomerRe.activateCustomer,
      _resetCustomer = _useShopifyCustomerRe.resetCustomer,
      _resetCustomerByUrl = _useShopifyCustomerRe.resetCustomerByUrl;
  return _merge(useShopifyCustomerResult, {
    actions: {
      // Activates the customer and sets the global customer access token.
      activateCustomer: function () {
        var _activateCustomer2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee6() {
          var result,
              _result$data3,
              accessToken,
              expiresAt,
              _args6 = arguments;

          return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  _context6.next = 2;
                  return _activateCustomer.apply(void 0, _args6);

                case 2:
                  result = _context6.sent;

                  if (result.data) {
                    _result$data3 = result.data, accessToken = _result$data3.accessToken, expiresAt = _result$data3.expiresAt;
                    dispatch({
                      type: 'SET_CUSTOMER_ACCESS_TOKEN',
                      payload: {
                        accessToken: accessToken,
                        expiresAt: expiresAt
                      }
                    });
                  }

                  return _context6.abrupt("return", result);

                case 5:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6);
        }));

        function activateCustomer() {
          return _activateCustomer2.apply(this, arguments);
        }

        return activateCustomer;
      }(),
      // Resets the customer and sets the global customer access token.
      resetCustomer: function () {
        var _resetCustomer2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee7() {
          var result,
              _result$data4,
              accessToken,
              expiresAt,
              _args7 = arguments;

          return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  _context7.next = 2;
                  return _resetCustomer.apply(void 0, _args7);

                case 2:
                  result = _context7.sent;

                  if (result.data) {
                    _result$data4 = result.data, accessToken = _result$data4.accessToken, expiresAt = _result$data4.expiresAt;
                    dispatch({
                      type: 'SET_CUSTOMER_ACCESS_TOKEN',
                      payload: {
                        accessToken: accessToken,
                        expiresAt: expiresAt
                      }
                    });
                  }

                  return _context7.abrupt("return", result);

                case 5:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee7);
        }));

        function resetCustomer() {
          return _resetCustomer2.apply(this, arguments);
        }

        return resetCustomer;
      }(),
      // Resets the customer and sets the global customer access token.
      resetCustomerByUrl: function () {
        var _resetCustomerByUrl2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee8() {
          var result,
              _result$data5,
              accessToken,
              expiresAt,
              _args8 = arguments;

          return regeneratorRuntime.wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  _context8.next = 2;
                  return _resetCustomerByUrl.apply(void 0, _args8);

                case 2:
                  result = _context8.sent;

                  if (result.data) {
                    _result$data5 = result.data, accessToken = _result$data5.accessToken, expiresAt = _result$data5.expiresAt;
                    dispatch({
                      type: 'SET_CUSTOMER_ACCESS_TOKEN',
                      payload: {
                        accessToken: accessToken,
                        expiresAt: expiresAt
                      }
                    });
                  }

                  return _context8.abrupt("return", result);

                case 5:
                case "end":
                  return _context8.stop();
              }
            }
          }, _callee8);
        }));

        function resetCustomerByUrl() {
          return _resetCustomerByUrl2.apply(this, arguments);
        }

        return resetCustomerByUrl;
      }()
    }
  });
};

export { ShopifyProvider, ShopifyProviderWithContext, useShopifyCheckout, useShopifyCheckoutWithContext, useShopifyCustomer, useShopifyCustomerAccessToken, useShopifyCustomerAccessTokenWithContext, useShopifyCustomerWithContext, useShopifyProduct, useShopifyProductVariant, useShopifyProductVariantWithContext, useShopifyReducer };
